# **********************************************************************
# Copyright 2017 VMware, Inc.  All rights reserved. VMware Confidential.
# **********************************************************************
# $Id$
# $DateTime$
# $Change$
# $Author$
# **********************************************************************
import nsx_logging
import json

import cli.commands.host_shared.ovs_util as ovs_util

from cli.commands.cli_command_provider import CliCommandProvider


lg = nsx_logging.getLogger("cli.commands.host_public_cloud.logical_switch")


class HostPublicCloudGetLogicalSwitchSummary(CliCommandProvider):
    def __call__(self, cmd_list):
        res = []
        lp_count = {}
        lp_list = ovs_util.get_lport_list()  # lport vni vni_status
        if not lp_list:
            return "MSG_HOST_PUBLIC_CLOUD_SHOW_LOGICAL_PORT_ERROR"
        for lport in lp_list:
            arr = lport[1].split(':')
            id = (arr[0] == "VNI", arr[1])
            if id not in lp_count:
                lp_count[id] = 1
            else:
                lp_count[id] = lp_count[id] + 1
        ls_list = ovs_util.get_logical_switches_on_vm()
        if not ls_list:
            return "MSG_HOST_PUBLIC_CLOUD_SHOW_LOGICAL_SWITCH_ERROR"
        for lswitch in ls_list:
            ls_uuid = lswitch[0]
            ls_id = (lswitch[1] == "VNI", lswitch[2])
            res.append({'uuid': ls_uuid, 'id': ls_id[1],
                        'is_vni': ls_id[0],
                        'num_ports': lp_count.get(ls_id, 0)})
        return "OK\n\n%s" % json.dumps(res)
