import sys
if sys.version_info < (3,):
    import httplib

    HTTP_PORT = httplib.HTTP_PORT
    HTTPS_PORT = httplib.HTTPS_PORT

    # status codes
    # informational
    CONTINUE = httplib.CONTINUE
    SWITCHING_PROTOCOLS = httplib.SWITCHING_PROTOCOLS
    PROCESSING = httplib.PROCESSING

    # successful
    OK = httplib.OK
    CREATED = httplib.CREATED
    ACCEPTED = httplib.ACCEPTED
    NON_AUTHORITATIVE_INFORMATION = httplib.NON_AUTHORITATIVE_INFORMATION
    NO_CONTENT = httplib.NO_CONTENT
    RESET_CONTENT = httplib.RESET_CONTENT
    PARTIAL_CONTENT = httplib.PARTIAL_CONTENT
    MULTI_STATUS = httplib.MULTI_STATUS
    IM_USED = httplib.IM_USED

    # redirection
    MULTIPLE_CHOICES = httplib.MULTIPLE_CHOICES
    MOVED_PERMANENTLY = httplib.MOVED_PERMANENTLY
    FOUND = httplib.FOUND
    SEE_OTHER = httplib.SEE_OTHER
    NOT_MODIFIED = httplib.NOT_MODIFIED
    USE_PROXY = httplib.USE_PROXY
    TEMPORARY_REDIRECT = httplib.TEMPORARY_REDIRECT

    # client error
    BAD_REQUEST = httplib.BAD_REQUEST
    UNAUTHORIZED = httplib.UNAUTHORIZED
    PAYMENT_REQUIRED = httplib.PAYMENT_REQUIRED
    FORBIDDEN = httplib.FORBIDDEN
    NOT_FOUND = httplib.NOT_FOUND
    METHOD_NOT_ALLOWED = httplib.METHOD_NOT_ALLOWED
    NOT_ACCEPTABLE = httplib.NOT_ACCEPTABLE
    PROXY_AUTHENTICATION_REQUIRED = httplib.PROXY_AUTHENTICATION_REQUIRED
    REQUEST_TIMEOUT = httplib.REQUEST_TIMEOUT
    CONFLICT = httplib.CONFLICT
    GONE = httplib.GONE
    LENGTH_REQUIRED = httplib.LENGTH_REQUIRED
    PRECONDITION_FAILED = httplib.PRECONDITION_FAILED
    REQUEST_ENTITY_TOO_LARGE = httplib.REQUEST_ENTITY_TOO_LARGE
    REQUEST_URI_TOO_LONG = httplib.REQUEST_URI_TOO_LONG
    UNSUPPORTED_MEDIA_TYPE = httplib.UNSUPPORTED_MEDIA_TYPE
    REQUESTED_RANGE_NOT_SATISFIABLE = httplib.REQUESTED_RANGE_NOT_SATISFIABLE
    EXPECTATION_FAILED = httplib.EXPECTATION_FAILED
    UNPROCESSABLE_ENTITY = httplib.UNPROCESSABLE_ENTITY
    LOCKED = httplib.LOCKED
    FAILED_DEPENDENCY = httplib.FAILED_DEPENDENCY
    UPGRADE_REQUIRED = httplib.UPGRADE_REQUIRED

    # server error
    INTERNAL_SERVER_ERROR = httplib.INTERNAL_SERVER_ERROR
    NOT_IMPLEMENTED = httplib.NOT_IMPLEMENTED
    BAD_GATEWAY = httplib.BAD_GATEWAY
    SERVICE_UNAVAILABLE = httplib.SERVICE_UNAVAILABLE
    GATEWAY_TIMEOUT = httplib.GATEWAY_TIMEOUT
    HTTP_VERSION_NOT_SUPPORTED = httplib.HTTP_VERSION_NOT_SUPPORTED
    INSUFFICIENT_STORAGE = httplib.INSUFFICIENT_STORAGE
    NOT_EXTENDED = httplib.NOT_EXTENDED

    # Mapping status codes to official W3C names
    responses = httplib.responses

    # maximal amount of data to read at one time in _safe_read
    MAXAMOUNT = httplib.MAXAMOUNT

    HTTPMessage = httplib.HTTPMessage
    HTTPResponse = httplib.HTTPResponse
    HTTPConnection = httplib.HTTPConnection
    HTTPSConnection = httplib.HTTPSConnection
    HTTPException = httplib.HTTPException
    NotConnected = httplib.NotConnected
    InvalidURL = httplib.InvalidURL
    UnknownProtocol = httplib.UnknownProtocol
    UnknownTransferEncoding = httplib.UnknownTransferEncoding
    UnimplementedFileMode = httplib.UnimplementedFileMode
    IncompleteRead = httplib.IncompleteRead
    ImproperConnectionState = httplib.ImproperConnectionState
    CannotSendRequest = httplib.CannotSendRequest
    CannotSendHeader = httplib.CannotSendHeader
    ResponseNotReady = httplib.ResponseNotReady
    BadStatusLine = httplib.BadStatusLine
    LineTooLong = httplib.LineTooLong

else:
    import http.client

    HTTP_PORT = http.client.HTTP_PORT
    HTTPS_PORT = http.client.HTTPS_PORT

    # status codes
    # informational
    CONTINUE = http.client.CONTINUE
    SWITCHING_PROTOCOLS = http.client.SWITCHING_PROTOCOLS
    PROCESSING = http.client.PROCESSING

    # successful
    OK = http.client.OK
    CREATED = http.client.CREATED
    ACCEPTED = http.client.ACCEPTED
    NON_AUTHORITATIVE_INFORMATION = http.client.NON_AUTHORITATIVE_INFORMATION
    NO_CONTENT = http.client.NO_CONTENT
    RESET_CONTENT = http.client.RESET_CONTENT
    PARTIAL_CONTENT = http.client.PARTIAL_CONTENT
    MULTI_STATUS = http.client.MULTI_STATUS
    IM_USED = http.client.IM_USED

    # redirection
    MULTIPLE_CHOICES = http.client.MULTIPLE_CHOICES
    MOVED_PERMANENTLY = http.client.MOVED_PERMANENTLY
    FOUND = http.client.FOUND
    SEE_OTHER = http.client.SEE_OTHER
    NOT_MODIFIED = http.client.NOT_MODIFIED
    USE_PROXY = http.client.USE_PROXY
    TEMPORARY_REDIRECT = http.client.TEMPORARY_REDIRECT

    # client error
    BAD_REQUEST = http.client.BAD_REQUEST
    UNAUTHORIZED = http.client.UNAUTHORIZED
    PAYMENT_REQUIRED = http.client.PAYMENT_REQUIRED
    FORBIDDEN = http.client.FORBIDDEN
    NOT_FOUND = http.client.NOT_FOUND
    METHOD_NOT_ALLOWED = http.client.METHOD_NOT_ALLOWED
    NOT_ACCEPTABLE = http.client.NOT_ACCEPTABLE
    PROXY_AUTHENTICATION_REQUIRED = http.client.PROXY_AUTHENTICATION_REQUIRED
    REQUEST_TIMEOUT = http.client.REQUEST_TIMEOUT
    CONFLICT = http.client.CONFLICT
    GONE = http.client.GONE
    LENGTH_REQUIRED = http.client.LENGTH_REQUIRED
    PRECONDITION_FAILED = http.client.PRECONDITION_FAILED
    REQUEST_ENTITY_TOO_LARGE = http.client.REQUEST_ENTITY_TOO_LARGE
    REQUEST_URI_TOO_LONG = http.client.REQUEST_URI_TOO_LONG
    UNSUPPORTED_MEDIA_TYPE = http.client.UNSUPPORTED_MEDIA_TYPE
    REQUESTED_RANGE_NOT_SATISFIABLE = http.client.REQUESTED_RANGE_NOT_SATISFIABLE
    EXPECTATION_FAILED = http.client.EXPECTATION_FAILED
    UNPROCESSABLE_ENTITY = http.client.UNPROCESSABLE_ENTITY
    LOCKED = http.client.LOCKED
    FAILED_DEPENDENCY = http.client.FAILED_DEPENDENCY
    UPGRADE_REQUIRED = http.client.UPGRADE_REQUIRED
    PRECONDITION_REQUIRED = http.client.PRECONDITION_REQUIRED
    TOO_MANY_REQUESTS = http.client.TOO_MANY_REQUESTS
    REQUEST_HEADER_FIELDS_TOO_LARGE = http.client.REQUEST_HEADER_FIELDS_TOO_LARGE

    # server error
    INTERNAL_SERVER_ERROR = http.client.INTERNAL_SERVER_ERROR
    NOT_IMPLEMENTED = http.client.NOT_IMPLEMENTED
    BAD_GATEWAY = http.client.BAD_GATEWAY
    SERVICE_UNAVAILABLE = http.client.SERVICE_UNAVAILABLE
    GATEWAY_TIMEOUT = http.client.GATEWAY_TIMEOUT
    HTTP_VERSION_NOT_SUPPORTED = http.client.HTTP_VERSION_NOT_SUPPORTED
    INSUFFICIENT_STORAGE = http.client.INSUFFICIENT_STORAGE
    NOT_EXTENDED = http.client.NOT_EXTENDED
    NETWORK_AUTHENTICATION_REQUIRED = http.client.NETWORK_AUTHENTICATION_REQUIRED

    # Mapping status codes to official W3C names
    responses = http.client.responses

    # maximal amount of data to read at one time in _safe_read
    try:
        MAXAMOUNT = http.client.MAXAMOUNT
    except:
        # Python 3.8 do not contains MAXAMOUNT
        # https://github.com/python/cpython/commit/d6bf6f2d0c83f0c64ce86e7b9340278627798090
        # (Ubuntu 20.04 contains python3.8)
        MAXAMOUNT = 1048576

    HTTPMessage = http.client.HTTPMessage
    HTTPResponse = http.client.HTTPResponse
    HTTPConnection = http.client.HTTPConnection
    HTTPSConnection = http.client.HTTPSConnection
    HTTPException = http.client.HTTPException
    NotConnected = http.client.NotConnected
    InvalidURL = http.client.InvalidURL
    UnknownProtocol = http.client.UnknownProtocol
    UnknownTransferEncoding = http.client.UnknownTransferEncoding
    UnimplementedFileMode = http.client.UnimplementedFileMode
    IncompleteRead = http.client.IncompleteRead
    ImproperConnectionState = http.client.ImproperConnectionState
    CannotSendRequest = http.client.CannotSendRequest
    CannotSendHeader = http.client.CannotSendHeader
    ResponseNotReady = http.client.ResponseNotReady
    BadStatusLine = http.client.BadStatusLine
    LineTooLong = http.client.LineTooLong
